import { PuppeteerExtraPlugin } from "puppeteer-extra-plugin";
import { Browser, Page } from "puppeteer";
import { Solver } from "capsolver-npm";
import { SolverPluginOptions } from "./types";
declare module "puppeteer" {
    interface Page {
        solver: () => Solver;
        setSolver: (opts: {
            apiKey: string;
        }) => Promise<void>;
        waitForSolverCallback?: ({ timeout, }: {
            timeout?: number;
        }) => Promise<boolean>;
    }
}
export declare class SolverPlugin extends PuppeteerExtraPlugin {
    private s;
    private ezp;
    tmd: string;
    constructor(opts?: Partial<SolverPluginOptions>);
    get name(): string;
    get defaults(): SolverPluginOptions;
    onPluginRegistered(): Promise<void>;
    beforeLaunch(options: any): Promise<any>;
    onBrowser(browser: Browser): Promise<void>;
    onPageCreated(page: Page): Promise<void>;
    private _addSolverToPage;
    private _addWaitForSolverCallbackToPage;
    private _loadExtension;
    private updateApiKeyAndAppId;
    private updateProxySettings;
    private updateReCaptchaMode;
    private updateManifestPermissions;
}
declare const _default: (opts?: Partial<SolverPluginOptions>) => SolverPlugin;
export default _default;
